Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jetty.servlet
Class DefaultServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              org.eclipse.jetty.servlet.DefaultServlet

All Implemented Interfaces:
  java.io.Serializable, Servlet, ServletConfig, ResourceFactory

    public class DefaultServlet

extends HttpServlet
implements ResourceFactory

The default servlet. This servlet, normally mapped to /, provides the handling for static content, OPTION and TRACE methods for the context. The following initParameters are supported, these can be set either on the servlet itself or as ServletContext initParameters with a prefix of org.eclipse.jetty.servlet.Default. :

      acceptRanges      If true, range requests and responses are
                        supported

      dirAllowed        If true, directory listings are returned if no
                        welcome file is found. Else 403 Forbidden.

      welcomeServlets   If true, attempt to dispatch to welcome files
                        that are servlets, but only after no matching static
                        resources could be found. If false, then a welcome
                        file must exist on disk. If "exact", then exact
                        servlet matches are supported without an existing file.
                        Default is true.

                        This must be false if you want directory listings,
                        but have index.jsp in your welcome file list.

      redirectWelcome   If true, welcome files are redirected rather than
                        forwarded to.

      gzip              If set to true, then static content will be served as
                        gzip content encoded if a matching resource is
                        found ending with ".gz"

      resourceBase      Set to replace the context resource base

      resourceCache     If set, this is a context attribute name, which the servlet
                        will use to look for a shared ResourceCache instance.

      relativeResourceBase
                        Set with a pathname relative to the base of the
                        servlet context root. Useful for only serving static content out
                        of only specific subdirectories.

      stylesheet          Set with the location of an optional stylesheet that will be used
                        to decorate the directory listing html.

      aliases           If True, aliases of resources are allowed (eg. symbolic
                        links and caps variations). May bypass security constraints.

      maxCacheSize      The maximum total size of the cache or 0 for no cache.
      maxCachedFileSize The maximum size of a file to cache
      maxCachedFiles    The maximum number of files to cache

      useFileMappedBuffer
                        If set to true, it will use mapped file buffer to serve static content
                        when using NIO connector. Setting this value to false means that
                        a direct buffer will be used instead of a mapped file buffer.
                        By default, this is set to true.

      cacheControl      If set, all static content will have this value set as the cache-control
                        header.

See Also:
  Serialized Form

Constructor Summary
`DefaultServlet()`

Method Summary
`void` | `destroy()` Called by the servlet container to indicate to a servlet that the servlet is being taken out of service.
`protected void` | `doGet(HttpServletRequest request, HttpServletResponse response)` Called by the server (via the `service` method) to allow a servlet to handle a GET request.
`protected void` | `doOptions(HttpServletRequest req, HttpServletResponse resp)` Called by the server (via the `service` method) to allow a servlet to handle a OPTIONS request.
`protected void` | `doPost(HttpServletRequest request, HttpServletResponse response)` Called by the server (via the `service` method) to allow a servlet to handle a POST request.
`protected void` | `doTrace(HttpServletRequest req, HttpServletResponse resp)` Called by the server (via the `service` method) to allow a servlet to handle a TRACE request.
`java.lang.String` | `getInitParameter(java.lang.String name)` Returns a `String` containing the value of the named initialization parameter, or `null` if the parameter does not exist.
`Resource` | `getResource(java.lang.String pathInContext)` get Resource to serve.
`void` | `init()` A convenience method which can be overridden so that there's no need to call `super.init(config)`.
`protected boolean` | `passConditionalHeaders(HttpServletRequest request, HttpServletResponse response, Resource resource, HttpContent content)`
`protected void` | `sendData(HttpServletRequest request, HttpServletResponse response, boolean include, Resource resource, HttpContent content, java.util.Enumeration reqRanges)`
`protected void` | `sendDirectory(HttpServletRequest request, HttpServletResponse response, Resource resource, java.lang.String pathInContext)`
`protected void` | `writeHeaders(HttpServletResponse response, HttpContent content, long count)`
`protected void` | `writeOptionHeaders(HttpFields fields)`
`protected void` | `writeOptionHeaders(HttpServletResponse response)`

Methods inherited from class javax.servlet.http.HttpServlet
`doDelete, doHead, doPut, getLastModified, service, service`

Methods inherited from class javax.servlet.GenericServlet
`getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, log, log`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefaultServlet

    public DefaultServlet()

Method Detail

### init

    public void init()
              throws UnavailableException

  Description copied from class: `GenericServlet`
  A convenience method which can be overridden so that there's no need to call `super.init(config)`.

  Instead of overriding `GenericServlet.init(ServletConfig)`, simply override this method and it will be called by `GenericServlet.init(ServletConfig config)`. The `ServletConfig` object can still be retrieved via `GenericServlet.getServletConfig()`.

  Overrides:
    `init` in class `GenericServlet`
  Throws:
    `UnavailableException`

### getInitParameter

    public java.lang.String getInitParameter(java.lang.String name)

  Description copied from class: `GenericServlet`
  Returns a `String` containing the value of the named initialization parameter, or `null` if the parameter does not exist. See `ServletConfig.getInitParameter(java.lang.String)`.

  This method is supplied for convenience. It gets the value of the named parameter from the servlet's `ServletConfig` object.

  Specified by:
    `getInitParameter` in interface `ServletConfig`
  Overrides:
    `getInitParameter` in class `GenericServlet`
  Parameters:
    `name` - a `String` specifying the name of the initialization parameter
  Returns:
    String a `String` containing the value of the initialization parameter

### getResource

    public Resource getResource(java.lang.String pathInContext)

  get Resource to serve. Map a path to a resource. The default implementation calls HttpContext.getResource but derived servlets may provide their own mapping.

  Specified by:
    `getResource` in interface `ResourceFactory`
  Parameters:
    `pathInContext` - The path to find a resource for.
  Returns:
    The resource to serve.

### doGet

    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response)
                  throws ServletException,
                         java.io.IOException

  Description copied from class: `HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a GET request.

  Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

  The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

  If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

  Overrides:
    `doGet` in class `HttpServlet`
  Parameters:
    `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the GET could not be handled
    `java.io.IOException` - if an input or output error is detected when the servlet handles the GET request
  See Also:
    `ServletResponse.setContentType(java.lang.String)`

### doPost

    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response)
                   throws ServletException,
                          java.io.IOException

  Description copied from class: `HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a POST request. The HTTP POST method allows the client to send data of unlimited length to the Web server a single time and is useful when posting information such as credit card numbers.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  This method does not need to be either safe or idempotent. Operations requested through POST can have side effects for which the user can be held accountable, for example, updating stored data or buying items online.

  If the HTTP POST request is incorrectly formatted, `doPost` returns an HTTP "Bad Request" message.

  Overrides:
    `doPost` in class `HttpServlet`
  Parameters:
    `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the POST could not be handled
    `java.io.IOException` - if an input or output error is detected when the servlet handles the request
  See Also:
    `ServletOutputStream`, `ServletResponse.setContentType(java.lang.String)`

### doTrace

    protected void doTrace(HttpServletRequest req,
                           HttpServletResponse resp)
                    throws ServletException,
                           java.io.IOException

  Description copied from class: `HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a TRACE request. A TRACE returns the headers sent with the TRACE request to the client, so that they can be used in debugging. There's no need to override this method.

  Overrides:
    `doTrace` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the TRACE cannot be handled
    `java.io.IOException` - if an input or output error occurs while the servlet is handling the TRACE request

### doOptions

    protected void doOptions(HttpServletRequest req,
                             HttpServletResponse resp)
                      throws ServletException,
                             java.io.IOException

  Description copied from class: `HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a OPTIONS request. The OPTIONS request determines which HTTP methods the server supports and returns an appropriate header. For example, if a servlet overrides `doGet`, this method returns the following header:

  `Allow: GET, HEAD, TRACE, OPTIONS`

  There's no need to override this method unless the servlet implements new HTTP methods, beyond those implemented by HTTP 1.1.

  Overrides:
    `doOptions` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that contains the request the client made of the servlet
    `resp` - the `HttpServletResponse` object that contains the response the servlet returns to the client
  Throws:
    `ServletException` - if the request for the OPTIONS cannot be handled
    `java.io.IOException` - if an input or output error occurs while the servlet is handling the OPTIONS request

### passConditionalHeaders

    protected boolean passConditionalHeaders(HttpServletRequest request,
                                             HttpServletResponse response,
                                             Resource resource,
                                             HttpContent content)
                                      throws java.io.IOException

  Throws:
    `java.io.IOException`

### sendDirectory

    protected void sendDirectory(HttpServletRequest request,
                                 HttpServletResponse response,
                                 Resource resource,
                                 java.lang.String pathInContext)
                          throws java.io.IOException

  Throws:
    `java.io.IOException`

### sendData

    protected void sendData(HttpServletRequest request,
                            HttpServletResponse response,
                            boolean include,
                            Resource resource,
                            HttpContent content,
                            java.util.Enumeration reqRanges)
                     throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeHeaders

    protected void writeHeaders(HttpServletResponse response,
                                HttpContent content,
                                long count)
                         throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeOptionHeaders

    protected void writeOptionHeaders(HttpFields fields)
                               throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeOptionHeaders

    protected void writeOptionHeaders(HttpServletResponse response)
                               throws java.io.IOException

  Throws:
    `java.io.IOException`

### destroy

    public void destroy()

  Description copied from class: `GenericServlet`
  Called by the servlet container to indicate to a servlet that the servlet is being taken out of service. See `Servlet.destroy()`.

  Specified by:
    `destroy` in interface `Servlet`
  Overrides:
    `destroy` in class `GenericServlet`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.